<template>
    <div class=" d-md-flex align-items-center flex-wrap justify-content-center mt-4 p-3 contenedorPrincipal">
        <label class="form-label mx-2  mb-0">Fecha Desde:</label>
        <input type="date" v-model="data.fecha_desde" class="form-label me-2 mb-0" id="fecha_desde" autocomplete="off"/>

        <label class="form-label mx-2  mb-0">Fecha Hasta:</label>
        <input type="date" v-model="data.fecha_hasta" class="form-label me-2  mb-0" id="fecha_hasta" autocomplete="off"/>

        <label class="form-label d-inline  mb-0">Solicitante:</label>
        <div class="col-3 ms-2">
            <auto-complete required class="form-label  mb-0" v-model="data.solicitante" :elements="usuarioStore.listadoSolicitantes" placeholder="Solicitante" :minLength="3" :disabled="false" />
        </div>
        <button v-show="enableComponent" type="button" class="btn btn-principal fs-7 px-2 mx-2"
            alt="Ver cupos del solicitante" title="Ver cupos del solicitante" @click="verCupos()">
            Ver cupos
        </button>
        <Modal ref="cuposModal" :size="'lg'" :title="cuposTitulo">
            <CuposModal :parametros="cuposParametros"></CuposModal>
        </Modal>

        <button title="Buscar Transferencia" type="button" class="mx-5 btn btn-principal px-2"
            @click="busquedaTransferencia()">
            <i class="bi bi-search"></i>
        </button>
        <br>
        <p class="fs-7  text-principal" v-if="data.solicitante !== undefined && data.solicitante != null && data.solicitante!.id_tabla_sol_reemplaza != null">Reemplazado por: <b> {{ data.solicitante.ayn_reemplaza }}.</b></p>
        <p class="fs-7" v-if="data.solicitante != null && data.solicitante!.id_tabla_sol_reemplaza == null"> El solicitante no posee un reemplazo.</p>
    </div>

    <div class="row mt-3">
        <div class="col-9"></div>
        <div class="col-3 text-end px-2">
            <button alt="Nueva Transferencia" title="Nueva Transferencia" v-show="enableComponent" type="button"
                class="btn btn-secondary mx-1 mt-4 p-1 px-2 mb-4" @click="goToFormularioTransferencia()">
                <i class="bi bi-plus-square mx-1 fonts-sm p-0"></i> NUEVA TRANSFERENCIA
            </button>
        </div>
    </div>
    <div class="row mt-3">
        <span id="tiene_plata" v-if="data.importe > 0">Tiene Dinero Transferido Desde Subsidios</span>
    </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, onMounted, computed, watch, ref } from "vue";
import { loading, urlApi } from "@/shared.js";
import http from "@/http";
import { AutoComplete, Modal } from "@hcd-bsas/vue3-components";
import Swal from 'sweetalert2'
import { useRouter, useRoute } from "vue-router";
// Entities
import Solicitante from "@/entities/Solicitante";
//store
import { useConfigStore } from "@/stores/configgral";
import { useUsuariosStore } from "@/stores/usuarios";
import { useTransferenciasStore } from "@/stores/transferencias/transferencias";
//components
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";


const cuposModal = ref(Modal);

const configStore = useConfigStore();
const usuarioStore = useUsuariosStore();
const transferenciasStore = useTransferenciasStore();
const router = useRouter();
const route = useRoute();

const data = reactive({
    importe: 0 as number,
    fecha_desde: "" as string,
    fecha_hasta: "" as string,
    solicitante: undefined as Solicitante | undefined,
    reemplazante: undefined as Solicitante | undefined,
});

const enableComponent = computed(() => {
    if (data.solicitante == null) {
        return false;
    } else { return true; }
});


const cuposParametros = computed(() => ({
    f_cupo_des: data.fecha_desde,
    f_cupo_has: data.fecha_hasta,
    id_tabla_sol: data.solicitante?.id_tabla_sol,
    usar_perfil_consulta: 0
}));

// const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";

const cuposTitulo = computed(() =>
    "Ajuste entre "+ data.solicitante?.ayn + " y " + data.solicitante?.ayn_reemplaza
);

onMounted(async () => {
    loading.show();
    await Promise.all([
        configStore.updateListadoPeriodo(),
        usuarioStore.updateListadoSolicitantes("B"),

    ]);
    var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
    data.fecha_desde = anio + "-03-01";
    data.fecha_hasta = anio + "-12-31";
    transferenciasStore.listadoTransferencias = [];

    var id_tabla_sol = Number(route.params.id_tabla_sol);
    data.solicitante = await usuarioStore.findSolicitanteById(id_tabla_sol);
    if (data.solicitante !== undefined) {
        busquedaTransferencia()
    }
    loading.hide();
});

async function busquedaTransferencia() {
    loading.show();
    if (data.solicitante == null) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: 'DEBE SELECIONAR UN SOLICITANTE',
        })
    } else {
        await transferenciasStore.updateListadoTransferenciasCabeceras({
            id_cargo: null,
            id_tabla_sol: data.solicitante?.id_tabla_sol,
            tipo_transf: "J",
            f_transf_desde: data.fecha_desde,
            f_transf_hasta: data.fecha_hasta,
        });
        var rta = await http.post(urlApi + "getTransferenciasdeSubsidiosImporte", {
            id_tabla_sol: data.solicitante?.id_tabla_sol,
        });
        if (rta.data.length > 0) {
            data.importe = rta.data[0].importe;
        } else {
            data.importe = 0;
        }
    }
    loading.hide();
}

function verCupos() {
    console.log(data.solicitante);
    if (data.solicitante?.id_tabla_sol_reemplaza == null) {
        Swal.fire({
            icon: "error",
            title: "Error",
            text: "El solicitante seleccionado no posee un reemplazo.",
        })
        return false;
    }

    cuposModal.value?.show();
}

watch(() => data.solicitante?.id_tabla_sol, async (newValue: any, oldValue: any) => {
    if (newValue == null) {
        transferenciasStore.listadoTransferencias = [];

    }
});

function goToFormularioTransferencia() {
    if (data.solicitante?.id_tabla_sol_reemplaza == null) {
        Swal.fire({
            icon: "error",
            title: "Error",
            text: "El solicitante seleccionado no posee un reemplazo.",
        })
        return false;
    }

    var anio_busqueda = data.fecha_desde.slice(0, 4);//uso la fecha desde (imagino que es la que se va a mover a 2022 ect)
    router.push({
        name: "editarTransfBajaSolicitante",
        params: { periodo: anio_busqueda, id_tabla_sol: data.solicitante?.id_tabla_sol },
    });
}
</script>

<style>
#tiene_plata {
    font-size: 200%;
    color: red;
}
</style>
